// Common/StdOutStream.h

#pragma once 

#ifndef __COMMON_STDOUTSTREAM_H
#define __COMMON_STDOUTSTREAM_H

#define	GetCommandLineW g_StdOut.MyGetCommandLineW

#include "../7-zip32.h"
#include "../Dialog.h"
#include "../SplitCmdLine.h"

class CStdOutStream
{
public:
	LPCWSTR GetTempSFXName();
//	LPCWSTR GetArchiveName();
//	void SetArchiveName(LPCWSTR lpArchiveName);
	LPWSTR MyGetCommandLineW();
	void SetCommandLine(const CSplitCmdLine& scl);
	LPCSTR CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize);
	void ReSet();
	HANDLE m_hThread;
	CProgressDialog* GetProgressDialog() { return m_pDlgProgress; }
	void CloseProgressDialog() { ::PostMessage(m_pDlgProgress->m_hWnd, WM_CLOSE, 0, 1); }
	void SetProgressDialog(CProgressDialog* pDlg) { m_pDlgProgress = pDlg; }
	BOOL SetUnicodeMode(BOOL bUnicode) { m_bUnicode = bUnicode; return TRUE; }
	BOOL GetUnicodeMode() { return m_bUnicode; }
	CStdOutStream ();
	~CStdOutStream ();
	
	CStdOutStream & operator<<(CStdOutStream & (* aFunction)(CStdOutStream  &));
	CStdOutStream & operator<<(const char *string);
	CStdOutStream & operator<<(const wchar_t *string);
	CStdOutStream & operator<<(char c);
	CStdOutStream & operator<<(int number);
	CStdOutStream & operator<<(UInt64 number);

protected:
	DWORD m_dwMaxBuf;
	DWORD m_dwBufSize;
	char* m_lpOutBuf;
	LPWSTR m_lpCommandLine;
	LPWSTR m_lpArchiveName;
	WCHAR m_lpTempSFXName[MAX_PATH];
	CProgressDialog* m_pDlgProgress;
	BOOL m_bUnicode;
	void OutProgress(const char* lpszText);
};

CStdOutStream & endl(CStdOutStream & anOut);

extern CStdOutStream g_StdOut;
extern CStdOutStream g_StdErr;

#endif
